//+------------------------------------------------------------------+ 
//| ARSI.mq4 
//+------------------------------------------------------------------+ 
#property copyright "Alexander Kirilyuk M." 
#property link "" 

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_width1 2

extern int ARSI1Period = 14;
extern int period = 20;
extern int ma_method = 2;
//---- buffers 
double ARSI[]; 
double ARSI1[]; 

int init()
{ 
	string short_name = "RSI adaptive EMA (" + ARSI1Period+")";
   IndicatorBuffers(2);
	SetIndexBuffer(0,ARSI); 
	SetIndexBuffer(1,ARSI1); 
	return(0); 
} 

int start() 
{ 
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   //

   for(i=limit; i >= 0; i--)
   {
		double sc = MathAbs(iRSI(NULL, 0, ARSI1Period, PRICE_CLOSE, i)/100.0 - 0.5) * 2.0;
		if( Bars - i <= ARSI1Period)
   			ARSI1[i] = Close[i];
		else	ARSI1[i] = ARSI1[i+1] + sc * (Close[i] - ARSI1[i+1]);
	}
   for(i = limit; i >= 0; i--) ARSI[i] = iMAOnArray(ARSI1,0,period,0,ma_method,i);
	return(0); 
} 


